;====================================================================
; Processor		: ATmega8515
; Compiler		: AVRASM
;====================================================================

;====================================================================
; DEFINITIONS
;====================================================================

.include "m8515def.inc"
.def temp = r16 ; temporary register
.def led_data = r17
.def counter = r20
.equ value = 20
.def ans = r22
.def score = r23

MAIN:
INIT_Z:
	ldi ZL, LOW(2*SESUATU)
	ldi ZH, HIGH(2*SESUATU)
	ldi counter, 3

INIT_STACK:
	ldi temp, low(RAMEND)
	ldi temp, high(RAMEND)
	out SPH, temp
	rjmp PROG


EVAL_TRUE:
	inc counter
	cpi counter,0
	breq LED_ON0
	cpi counter, 1
	breq LED_ON1
	cpi counter, 2
	breq LED_ON2
	cpi counter, 3
	breq LED_ON3
	cpi counter, 4
	breq LED_ON4
	cpi counter, 5
	breq LED_ON5

PROG:
	
	lpm
	adiw ZL, 1
	mov ans, r0
	cpi ans, value
	breq EVAL_TRUE

EVAL_WRONG:
	dec counter
	cpi counter,0
	breq LED_ON0
	cpi counter, 1
	breq LED_ON1
	cpi counter, 2
	breq LED_ON2
	cpi counter, 3
	breq LED_ON3
	cpi counter, 4
	breq LED_ON4
	cpi counter, 5
	breq LED_ON5
	

INIT_LED:

	ser temp ; load $FF to temp
	out DDRE,temp ; Set PORTA to output

LED_ON0:
	ldi led_data,0x00
	out PORTE,led_data ; Update LEDS
	rcall DELAY_02
	rjmp PROG

LED_ON1:
	ldi led_data,0x80
	out PORTE,led_data ; Update LEDS
	rcall DELAY_02
	rjmp PROG

LED_ON2:
	ldi led_data,0xC0
	out PORTE,led_data ; Update LEDS
	rcall DELAY_02
	rjmp PROG

LED_ON3:
	ldi led_data,0xE0
	out PORTE,led_data ; Update LEDS
	rcall DELAY_02
	rjmp PROG

LED_ON4:
	ldi led_data,0xF0
	out PORTE,led_data ; Update LEDS
	rcall DELAY_02
	rjmp PROG

LED_ON5:
	ldi led_data,0xF8
	out PORTE,led_data ; Update LEDS
	rcall DELAY_02
	inc score
	ldi counter, 0
	rjmp LED_ON0


forever:
	rjmp forever
	

DELAY_00:
	; Generated by delay loop calculator
	; at http://www.bretmulvey.com/avrdelay.html
	;
	; Delay 4 000 cycles
	; 500us at 8.0 MHz

	    ldi  r18, 6
	    ldi  r19, 49
	L0: dec  r19
	    brne L0
	    dec  r18
	    brne L0
	ret

DELAY_01:
	; Generated by delay loop calculator
	; at http://www.bretmulvey.com/avrdelay.html
	;
	; DELAY_CONTROL 40 000 cycles
	; 5ms at 8.0 MHz

	    ldi  r18, 52
	    ldi  r19, 242
	L1: dec  r19
	    brne L1
	    dec  r18
	    brne L1
	    nop
	ret

DELAY_02:
; Generated by delay loop calculator
; at http://www.bretmulvey.com/avrdelay.html
;
; Delay 160 000 cycles
; 20ms at 8.0 MHz

	    ldi  r18, 208
	    ldi  r19, 202
	L2: dec  r19
	    brne L2
	    dec  r18
	    brne L2
	    nop
		ret


SESUATU:
.db 20, 20, 20
